/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// FeeEstimate struct for FeeEstimate
type FeeEstimate struct {
	// The fast maximum priority fee.
	Fast *bigInt `json:"fast,omitempty"`
	// The medium maximum priority fee.
	Medium *bigInt `json:"medium,omitempty"`
	// The slow maximum priority fee.
	Slow *bigInt `json:"slow,omitempty"`
}

// NewFeeEstimate instantiates a new FeeEstimate object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFeeEstimate() *FeeEstimate {
	this := FeeEstimate{}
	return &this
}

// NewFeeEstimateWithDefaults instantiates a new FeeEstimate object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFeeEstimateWithDefaults() *FeeEstimate {
	this := FeeEstimate{}
	return &this
}

// GetFast returns the Fast field value if set, zero value otherwise.
func (o *FeeEstimate) GetFast() bigInt {
	if o == nil || o.Fast == nil {
		var ret bigInt
		return ret
	}
	return *o.Fast
}

// GetFastOk returns a tuple with the Fast field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FeeEstimate) GetFastOk() (*bigInt, bool) {
	if o == nil || o.Fast == nil {
		return nil, false
	}
	return o.Fast, true
}

// HasFast returns a boolean if a field has been set.
func (o *FeeEstimate) HasFast() bool {
	if o != nil && o.Fast != nil {
		return true
	}

	return false
}

// SetFast gets a reference to the given bigInt and assigns it to the Fast field.
func (o *FeeEstimate) SetFast(v bigInt) {
	o.Fast = &v
}

// GetMedium returns the Medium field value if set, zero value otherwise.
func (o *FeeEstimate) GetMedium() bigInt {
	if o == nil || o.Medium == nil {
		var ret bigInt
		return ret
	}
	return *o.Medium
}

// GetMediumOk returns a tuple with the Medium field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FeeEstimate) GetMediumOk() (*bigInt, bool) {
	if o == nil || o.Medium == nil {
		return nil, false
	}
	return o.Medium, true
}

// HasMedium returns a boolean if a field has been set.
func (o *FeeEstimate) HasMedium() bool {
	if o != nil && o.Medium != nil {
		return true
	}

	return false
}

// SetMedium gets a reference to the given bigInt and assigns it to the Medium field.
func (o *FeeEstimate) SetMedium(v bigInt) {
	o.Medium = &v
}

// GetSlow returns the Slow field value if set, zero value otherwise.
func (o *FeeEstimate) GetSlow() bigInt {
	if o == nil || o.Slow == nil {
		var ret bigInt
		return ret
	}
	return *o.Slow
}

// GetSlowOk returns a tuple with the Slow field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FeeEstimate) GetSlowOk() (*bigInt, bool) {
	if o == nil || o.Slow == nil {
		return nil, false
	}
	return o.Slow, true
}

// HasSlow returns a boolean if a field has been set.
func (o *FeeEstimate) HasSlow() bool {
	if o != nil && o.Slow != nil {
		return true
	}

	return false
}

// SetSlow gets a reference to the given bigInt and assigns it to the Slow field.
func (o *FeeEstimate) SetSlow(v bigInt) {
	o.Slow = &v
}

func (o FeeEstimate) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Fast != nil {
		toSerialize["fast"] = o.Fast
	}
	if o.Medium != nil {
		toSerialize["medium"] = o.Medium
	}
	if o.Slow != nil {
		toSerialize["slow"] = o.Slow
	}
	return json.Marshal(toSerialize)
}

type NullableFeeEstimate struct {
	value *FeeEstimate
	isSet bool
}

func (v NullableFeeEstimate) Get() *FeeEstimate {
	return v.value
}

func (v *NullableFeeEstimate) Set(val *FeeEstimate) {
	v.value = val
	v.isSet = true
}

func (v NullableFeeEstimate) IsSet() bool {
	return v.isSet
}

func (v *NullableFeeEstimate) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFeeEstimate(val *FeeEstimate) *NullableFeeEstimate {
	return &NullableFeeEstimate{value: val, isSet: true}
}

func (v NullableFeeEstimate) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFeeEstimate) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
